diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -7717,264 +3037,276 @@ test_unique_constants ()
   tree int_42 = build_int_cst (integer_type_node, 42);
 
   test_region_model_context ctxt;
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
   ASSERT_EQ (model.get_rvalue (int_0, &ctxt), model.get_rvalue (int_0, &ctxt));
   ASSERT_EQ (model.get_rvalue (int_42, &ctxt),
 	     model.get_rvalue (int_42, &ctxt));
   ASSERT_NE (model.get_rvalue (int_0, &ctxt), model.get_rvalue (int_42, &ctxt));
   ASSERT_EQ (ctxt.get_num_diagnostics (), 0);
-}
-
-/* Check that operator== and hashing works as expected for the
-   various svalue subclasses.  */
 
-static void
-test_svalue_equality ()
-{
-  tree int_42 = build_int_cst (integer_type_node, 42);
-  tree int_0 = build_int_cst (integer_type_node, 0);
-
-  /* Create pairs instances of the various subclasses of svalue,
-     testing for hash and equality between (this, this) and
-     (this, other of same subclass). */
-  svalue *ptr_to_r0
-    = new region_svalue (ptr_type_node, region_id::from_int (0));
-  svalue *ptr_to_r1
-    = new region_svalue (ptr_type_node, region_id::from_int (1));
-
-  ASSERT_EQ (ptr_to_r0->hash (), ptr_to_r0->hash ());
-  ASSERT_EQ (*ptr_to_r0, *ptr_to_r0);
-
-  ASSERT_NE (ptr_to_r0->hash (), ptr_to_r1->hash ());
-  ASSERT_NE (*ptr_to_r0, *ptr_to_r1);
-
-  svalue *cst_int_42 = new constant_svalue (int_42);
-  svalue *cst_int_0 = new constant_svalue (int_0);
-
-  ASSERT_EQ (cst_int_42->hash (), cst_int_42->hash ());
-  ASSERT_EQ (*cst_int_42, *cst_int_42);
-
-  ASSERT_NE (cst_int_42->hash (), cst_int_0->hash ());
-  ASSERT_NE (*cst_int_42, *cst_int_0);
-
-  svalue *unknown_0 = new unknown_svalue (ptr_type_node);
-  svalue *unknown_1 = new unknown_svalue (ptr_type_node);
-  ASSERT_EQ (unknown_0->hash (), unknown_0->hash ());
-  ASSERT_EQ (*unknown_0, *unknown_0);
-  ASSERT_EQ (*unknown_1, *unknown_1);
-
-  /* Comparisons between different kinds of svalue.  */
-  ASSERT_NE (*ptr_to_r0, *cst_int_42);
-  ASSERT_NE (*ptr_to_r0, *unknown_0);
-  ASSERT_NE (*cst_int_42, *ptr_to_r0);
-  ASSERT_NE (*cst_int_42, *unknown_0);
-  ASSERT_NE (*unknown_0, *ptr_to_r0);
-  ASSERT_NE (*unknown_0, *cst_int_42);
-
-  delete ptr_to_r0;
-  delete ptr_to_r1;
-  delete cst_int_42;
-  delete cst_int_0;
-  delete unknown_0;
-  delete unknown_1;
+  /* A "(const int)42" will be a different tree from "(int)42)"...  */
+  tree const_int_type_node
+    = build_qualified_type (integer_type_node, TYPE_QUAL_CONST);
+  tree const_int_42 = build_int_cst (const_int_type_node, 42);
+  ASSERT_NE (int_42, const_int_42);
+  /* It should have a different const_svalue.  */
+  const svalue *int_42_sval = model.get_rvalue (int_42, &ctxt);
+  const svalue *const_int_42_sval = model.get_rvalue (const_int_42, &ctxt);
+  ASSERT_NE (int_42_sval, const_int_42_sval);
+  /* But they should compare as equal.  */
+  ASSERT_CONDITION_TRUE (model, int_42_sval, EQ_EXPR, const_int_42_sval);
+  ASSERT_CONDITION_FALSE (model, int_42_sval, NE_EXPR, const_int_42_sval);
 }
 
-/* Check that operator== and hashing works as expected for the
-   various region subclasses.  */
+/* Verify that each type gets its own singleton unknown_svalue within a
+   region_model_manager, and that NULL_TREE gets its own singleton.  */
 
 static void
-test_region_equality ()
+test_unique_unknowns ()
 {
-  region *r0
-    = new primitive_region (region_id::from_int (3), integer_type_node);
-  region *r1
-    = new primitive_region (region_id::from_int (4), integer_type_node);
-
-  ASSERT_EQ (*r0, *r0);
-  ASSERT_EQ (r0->hash (), r0->hash ());
-  ASSERT_NE (*r0, *r1);
-  ASSERT_NE (r0->hash (), r1->hash ());
+  region_model_manager mgr;
+  const svalue *unknown_int
+    = mgr.get_or_create_unknown_svalue (integer_type_node);
+  /* Repeated calls with the same type should get the same "unknown"
+     svalue.  */
+  const svalue *unknown_int_2
+    = mgr.get_or_create_unknown_svalue (integer_type_node);
+  ASSERT_EQ (unknown_int, unknown_int_2);
 
-  delete r0;
-  delete r1;
+  /* Different types (or the NULL type) should have different
+     unknown_svalues.  */
+  const svalue *unknown_NULL_type = mgr.get_or_create_unknown_svalue (NULL);
+  ASSERT_NE (unknown_NULL_type, unknown_int);
 
-  // TODO: test coverage for the map within a map_region
+  /* Repeated calls with NULL for the type should get the same "unknown"
+     svalue.  */
+  const svalue *unknown_NULL_type_2 = mgr.get_or_create_unknown_svalue (NULL);
+  ASSERT_EQ (unknown_NULL_type, unknown_NULL_type_2);
 }
 
-/* A subclass of purge_criteria for selftests: purge all svalue_id instances.  */
-
-class purge_all_svalue_ids : public purge_criteria
-{
-public:
-  bool should_purge_p (svalue_id) const FINAL OVERRIDE
-  {
-    return true;
-  }
-};
-
-/* A subclass of purge_criteria: purge a specific svalue_id.  */
+/* Verify that initial_svalue are handled as expected.  */
 
-class purge_one_svalue_id : public purge_criteria
+static void
+test_initial_svalue_folding ()
 {
-public:
-  purge_one_svalue_id (svalue_id victim) : m_victim (victim) {}
-
-  purge_one_svalue_id (region_model model, tree expr)
-  : m_victim (model.get_rvalue (expr, NULL)) {}
+  region_model_manager mgr;
+  tree x = build_global_decl ("x", integer_type_node);
+  tree y = build_global_decl ("y", integer_type_node);
 
-  bool should_purge_p (svalue_id sid) const FINAL OVERRIDE
-  {
-    return sid == m_victim;
-  }
+  test_region_model_context ctxt;
+  region_model model (&mgr);
+  const svalue *x_init = model.get_rvalue (x, &ctxt);
+  const svalue *y_init = model.get_rvalue (y, &ctxt);
+  ASSERT_NE (x_init, y_init);
+  const region *x_reg = model.get_lvalue (x, &ctxt);
+  ASSERT_EQ (x_init, mgr.get_or_create_initial_value (x_reg));
 
-private:
-  svalue_id m_victim;
-};
+}
 
-/* Check that constraint_manager::purge works for individual svalue_ids.  */
+/* Verify that unary ops are folded as expected.  */
 
 static void
-test_purging_by_criteria ()
+test_unaryop_svalue_folding ()
 {
-  tree int_42 = build_int_cst (integer_type_node, 42);
-  tree int_0 = build_int_cst (integer_type_node, 0);
-
+  region_model_manager mgr;
   tree x = build_global_decl ("x", integer_type_node);
   tree y = build_global_decl ("y", integer_type_node);
 
-  {
-    region_model model0;
-    region_model model1;
-
-    ADD_SAT_CONSTRAINT (model1, x, EQ_EXPR, y);
-    ASSERT_NE (model0, model1);
-
-    purge_stats stats_for_px;
-    purge_one_svalue_id px (model1, x);
-    model1.get_constraints ()->purge (px, &stats_for_px);
-    ASSERT_EQ (stats_for_px.m_num_equiv_classes, 0);
-
-    purge_stats stats_for_py;
-    purge_one_svalue_id py (model1.get_rvalue (y, NULL));
-    model1.get_constraints ()->purge (py, &stats_for_py);
-    ASSERT_EQ (stats_for_py.m_num_equiv_classes, 1);
-
-    ASSERT_EQ (*model0.get_constraints (), *model1.get_constraints ());
-  }
-
-  {
-    region_model model0;
-    region_model model1;
-
-    ADD_SAT_CONSTRAINT (model1, x, EQ_EXPR, int_42);
-    ASSERT_NE (model0, model1);
-    ASSERT_CONDITION_TRUE (model1, x, EQ_EXPR, int_42);
-
-    purge_stats stats;
-    model1.get_constraints ()->purge (purge_one_svalue_id (model1, x), &stats);
-
-    ASSERT_CONDITION_UNKNOWN (model1, x, EQ_EXPR, int_42);
-  }
-
-  {
-    region_model model0;
-    region_model model1;
-
-    ADD_SAT_CONSTRAINT (model1, x, GE_EXPR, int_0);
-    ADD_SAT_CONSTRAINT (model1, x, LE_EXPR, int_42);
-    ASSERT_NE (model0, model1);
-
-    ASSERT_CONDITION_TRUE (model1, x, GE_EXPR, int_0);
-    ASSERT_CONDITION_TRUE (model1, x, LE_EXPR, int_42);
+  test_region_model_context ctxt;
+  region_model model (&mgr);
+  const svalue *x_init = model.get_rvalue (x, &ctxt);
+  const svalue *y_init = model.get_rvalue (y, &ctxt);
+  const region *x_reg = model.get_lvalue (x, &ctxt);
+  ASSERT_EQ (x_init, mgr.get_or_create_initial_value (x_reg));
+
+  /* "(int)x" -> "x".  */
+  ASSERT_EQ (x_init, mgr.get_or_create_cast (integer_type_node, x_init));
+
+  /* "(void *)x" -> something other than "x".  */
+  ASSERT_NE (x_init, mgr.get_or_create_cast (ptr_type_node, x_init));
+
+  /* "!(x == y)" -> "x != y".  */
+  ASSERT_EQ (mgr.get_or_create_unaryop
+	       (boolean_type_node, TRUTH_NOT_EXPR,
+		mgr.get_or_create_binop (boolean_type_node, EQ_EXPR,
+					 x_init, y_init)),
+	     mgr.get_or_create_binop (boolean_type_node, NE_EXPR,
+				      x_init, y_init));
+  /* "!(x > y)" -> "x <= y".  */
+  ASSERT_EQ (mgr.get_or_create_unaryop
+	       (boolean_type_node, TRUTH_NOT_EXPR,
+		mgr.get_or_create_binop (boolean_type_node, GT_EXPR,
+					 x_init, y_init)),
+	     mgr.get_or_create_binop (boolean_type_node, LE_EXPR,
+				      x_init, y_init));
+}
+
+/* Verify that binops on constant svalues are folded.  */
 
-    purge_stats stats;
-    model1.get_constraints ()->purge (purge_one_svalue_id (model1, x), &stats);
+static void
+test_binop_svalue_folding ()
+{
+#define NUM_CSTS 10
+  tree cst_int[NUM_CSTS];
+  region_model_manager mgr;
+  const svalue *cst_sval[NUM_CSTS];
+  for (int i = 0; i < NUM_CSTS; i++)
+    {
+      cst_int[i] = build_int_cst (integer_type_node, i);
+      cst_sval[i] = mgr.get_or_create_constant_svalue (cst_int[i]);
+      ASSERT_EQ (cst_sval[i]->get_kind (), SK_CONSTANT);
+      ASSERT_EQ (cst_sval[i]->maybe_get_constant (), cst_int[i]);
+    }
 
-    ASSERT_CONDITION_UNKNOWN (model1, x, GE_EXPR, int_0);
-    ASSERT_CONDITION_UNKNOWN (model1, x, LE_EXPR, int_42);
-  }
+  for (int i = 0; i < NUM_CSTS; i++)
+    for (int j = 0; j < NUM_CSTS; j++)
+      {
+	if (i != j)
+	  ASSERT_NE (cst_sval[i], cst_sval[j]);
+	if (i + j < NUM_CSTS)
+	  {
+	    const svalue *sum
+	      = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
+					 cst_sval[i], cst_sval[j]);
+	    ASSERT_EQ (sum, cst_sval[i + j]);
+	  }
+	if (i - j >= 0)
+	  {
+	    const svalue *difference
+	      = mgr.get_or_create_binop (integer_type_node, MINUS_EXPR,
+					 cst_sval[i], cst_sval[j]);
+	    ASSERT_EQ (difference, cst_sval[i - j]);
+	  }
+	if (i * j < NUM_CSTS)
+	  {
+	    const svalue *product
+	      = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
+					 cst_sval[i], cst_sval[j]);
+	    ASSERT_EQ (product, cst_sval[i * j]);
+	  }
+	const svalue *eq = mgr.get_or_create_binop (integer_type_node, EQ_EXPR,
+					       cst_sval[i], cst_sval[j]);
+	ASSERT_EQ (eq, i == j ? cst_sval[1] : cst_sval [0]);
+	const svalue *neq = mgr.get_or_create_binop (integer_type_node, NE_EXPR,
+						cst_sval[i], cst_sval[j]);
+	ASSERT_EQ (neq, i != j ? cst_sval[1] : cst_sval [0]);
+	// etc
+      }
 
-  {
-    region_model model0;
-    region_model model1;
+  tree x = build_global_decl ("x", integer_type_node);
 
-    ADD_SAT_CONSTRAINT (model1, x, NE_EXPR, int_42);
-    ADD_SAT_CONSTRAINT (model1, y, NE_EXPR, int_0);
-    ASSERT_NE (model0, model1);
-    ASSERT_CONDITION_TRUE (model1, x, NE_EXPR, int_42);
-    ASSERT_CONDITION_TRUE (model1, y, NE_EXPR, int_0);
+  test_region_model_context ctxt;
+  region_model model (&mgr);
+  const svalue *x_init = model.get_rvalue (x, &ctxt);
+
+  /* PLUS_EXPR folding.  */
+  const svalue *x_init_plus_zero
+    = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
+			       x_init, cst_sval[0]);
+  ASSERT_EQ (x_init_plus_zero, x_init);
+  const svalue *zero_plus_x_init
+    = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
+			       cst_sval[0], x_init);
+  ASSERT_EQ (zero_plus_x_init, x_init);
+
+  /* MULT_EXPR folding.  */
+  const svalue *x_init_times_zero
+    = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
+			       x_init, cst_sval[0]);
+  ASSERT_EQ (x_init_times_zero, cst_sval[0]);
+  const svalue *zero_times_x_init
+    = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
+			       cst_sval[0], x_init);
+  ASSERT_EQ (zero_times_x_init, cst_sval[0]);
+
+  const svalue *x_init_times_one
+    = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
+			       x_init, cst_sval[1]);
+  ASSERT_EQ (x_init_times_one, x_init);
+  const svalue *one_times_x_init
+    = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
+			       cst_sval[1], x_init);
+  ASSERT_EQ (one_times_x_init, x_init);
+
+  // etc
+  // TODO: do we want to use the match-and-simplify DSL for this?
+
+  /* Verify that binops put any constants on the RHS.  */
+  const svalue *four_times_x_init
+    = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
+			       cst_sval[4], x_init);
+  const svalue *x_init_times_four
+    = mgr.get_or_create_binop (integer_type_node, MULT_EXPR,
+			       x_init, cst_sval[4]);
+  ASSERT_EQ (four_times_x_init, x_init_times_four);
+  const binop_svalue *binop = four_times_x_init->dyn_cast_binop_svalue ();
+  ASSERT_EQ (binop->get_op (), MULT_EXPR);
+  ASSERT_EQ (binop->get_arg0 (), x_init);
+  ASSERT_EQ (binop->get_arg1 (), cst_sval[4]);
+
+  /* Verify that ((x + 1) + 1) == (x + 2).  */
+  const svalue *x_init_plus_one
+    = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
+			       x_init, cst_sval[1]);
+  const svalue *x_init_plus_two
+    = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
+			       x_init, cst_sval[2]);
+  const svalue *x_init_plus_one_plus_one
+    = mgr.get_or_create_binop (integer_type_node, PLUS_EXPR,
+			       x_init_plus_one, cst_sval[1]);
+  ASSERT_EQ (x_init_plus_one_plus_one, x_init_plus_two);
+}
+
+/* Verify that sub_svalues are folded as expected.  */
 
-    purge_stats stats;
-    model1.get_constraints ()->purge (purge_one_svalue_id (model1, x), &stats);
-    ASSERT_NE (model0, model1);
+static void
+test_sub_svalue_folding ()
+{
+  coord_test ct;
+  tree c = build_global_decl ("c", ct.m_coord_type);
+  tree c_x = build3 (COMPONENT_REF, TREE_TYPE (ct.m_x_field),
+		     c, ct.m_x_field, NULL_TREE);
 
-    ASSERT_CONDITION_UNKNOWN (model1, x, NE_EXPR, int_42);
-    ASSERT_CONDITION_TRUE (model1, y, NE_EXPR, int_0);
-  }
+  region_model_manager mgr;
+  region_model model (&mgr);
+  test_region_model_context ctxt;
+  const region *c_x_reg = model.get_lvalue (c_x, &ctxt);
 
-  {
-    region_model model0;
-    region_model model1;
-
-    ADD_SAT_CONSTRAINT (model1, x, NE_EXPR, int_42);
-    ADD_SAT_CONSTRAINT (model1, y, NE_EXPR, int_0);
-    ASSERT_NE (model0, model1);
-    ASSERT_CONDITION_TRUE (model1, x, NE_EXPR, int_42);
-    ASSERT_CONDITION_TRUE (model1, y, NE_EXPR, int_0);
-
-    purge_stats stats;
-    model1.get_constraints ()->purge (purge_all_svalue_ids (), &stats);
-    ASSERT_CONDITION_UNKNOWN (model1, x, NE_EXPR, int_42);
-    ASSERT_CONDITION_UNKNOWN (model1, y, NE_EXPR, int_0);
-  }
+  /* Verify that sub_svalue of "unknown" simply
+     yields an unknown.  */
 
+  const svalue *unknown = mgr.get_or_create_unknown_svalue (ct.m_coord_type);
+  const svalue *sub = mgr.get_or_create_sub_svalue (TREE_TYPE (ct.m_x_field),
+						      unknown, c_x_reg);
+  ASSERT_EQ (sub->get_kind (), SK_UNKNOWN);
+  ASSERT_EQ (sub->get_type (), TREE_TYPE (ct.m_x_field));
 }
 
-/* Test that region_model::purge_unused_svalues works as expected.  */
+/* Test that region::descendent_of_p works as expected.  */
 
 static void
-test_purge_unused_svalues ()
+test_descendent_of_p ()
 {
-  tree int_42 = build_int_cst (integer_type_node, 42);
-  tree int_0 = build_int_cst (integer_type_node, 0);
-  tree x = build_global_decl ("x", integer_type_node);
-  tree y = build_global_decl ("y", integer_type_node);
-
-  test_region_model_context ctxt;
-  region_model model;
-  model.set_to_new_unknown_value (model.get_lvalue (x, &ctxt), TREE_TYPE (x),
-				  &ctxt);
-  model.set_to_new_unknown_value (model.get_lvalue (x, &ctxt), TREE_TYPE (x),
-				  &ctxt);
-  model.set_to_new_unknown_value (model.get_lvalue (x, &ctxt), TREE_TYPE (x),
-				  &ctxt);
-  model.add_constraint (x, NE_EXPR, int_42, &ctxt);
-
-  model.set_value (model.get_lvalue (x, &ctxt),
-		   model.get_rvalue (int_42, &ctxt),
-		   &ctxt);
-  model.add_constraint (y, GT_EXPR, int_0, &ctxt);
-
-  /* The redundant unknown values should have been purged.  */
-  purge_stats purged;
-  model.purge_unused_svalues (&purged, NULL);
-  ASSERT_EQ (purged.m_num_svalues, 3);
+  region_model_manager mgr;
+  const region *stack = mgr.get_stack_region ();
+  const region *heap = mgr.get_heap_region ();
+  const region *code = mgr.get_code_region ();
+  const region *globals = mgr.get_globals_region ();
 
-  /* and the redundant constraint on an old, unknown value for x should
-     have been purged.  */
-  ASSERT_EQ (purged.m_num_equiv_classes, 1);
-  ASSERT_EQ (purged.m_num_constraints, 1);
-  ASSERT_EQ (model.get_constraints ()->m_constraints.length (), 2);
+  /* descendent_of_p should return true when used on the region itself.  */
+  ASSERT_TRUE (stack->descendent_of_p (stack));
+  ASSERT_FALSE (stack->descendent_of_p (heap));
+  ASSERT_FALSE (stack->descendent_of_p (code));
+  ASSERT_FALSE (stack->descendent_of_p (globals));
 
-  /* ...but we should still have x == 42.  */
-  ASSERT_EQ (model.eval_condition (x, EQ_EXPR, int_42, &ctxt),
-	     tristate::TS_TRUE);
-
-  /* ...and we should still have the constraint on y.  */
-  ASSERT_EQ (model.eval_condition (y, GT_EXPR, int_0, &ctxt),
-	     tristate::TS_TRUE);
+  tree x = build_global_decl ("x", integer_type_node);
+  const region *x_reg = mgr.get_region_for_global (x);
+  ASSERT_TRUE (x_reg->descendent_of_p (globals));
 
-  ASSERT_EQ (ctxt.get_num_diagnostics (), 0);
+  /* A cast_region should be a descendent of the original region.  */
+  const region *cast_reg = mgr.get_cast_region (x_reg, ptr_type_node);
+  ASSERT_TRUE (cast_reg->descendent_of_p (x_reg));
 }
 
 /* Verify that simple assignments work as expected.  */
@@ -7987,7 +3319,8 @@ test_assignment ()
   tree y = build_global_decl ("y", integer_type_node);
 
   /* "x == 0", then use of y, then "y = 0;".  */
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
   ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, int_0);
   ASSERT_CONDITION_UNKNOWN (model, y, EQ_EXPR, int_0);
   model.set_value (model.get_lvalue (y, NULL),
@@ -7995,8 +3328,6 @@ test_assignment ()
 		   NULL);
   ASSERT_CONDITION_TRUE (model, y, EQ_EXPR, int_0);
   ASSERT_CONDITION_TRUE (model, y, EQ_EXPR, x);
-
-  ASSERT_DUMP_EQ (model, true, "y: 0, {x}: unknown, x == y");
 }
 
 /* Verify that compound assignments work as expected.  */
@@ -8020,12 +3351,11 @@ test_compound_assignment ()
   tree int_17 = build_int_cst (integer_type_node, 17);
   tree int_m3 = build_int_cst (integer_type_node, -3);
 
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
   model.set_value (c_x, int_17, NULL);
   model.set_value (c_y, int_m3, NULL);
 
-  ASSERT_DUMP_EQ (model, true, "c.x: 17, c.y: -3");
-
   /* Copy c to d.  */
   model.copy_region (model.get_lvalue (d, NULL), model.get_lvalue (c, NULL),
 		     NULL);
@@ -8076,101 +3406,84 @@ test_stack_frames ()
   /* "q" global.  */
   tree q = build_global_decl ("q", ptr_type_node);
 
+  region_model_manager mgr;
   test_region_model_context ctxt;
-  region_model model;
+  region_model model (&mgr);
 
   /* Push stack frame for "parent_fn".  */
-  region_id parent_frame_rid
-    = model.push_frame (DECL_STRUCT_FUNCTION (parent_fndecl), NULL, &ctxt);
-  ASSERT_EQ (model.get_current_frame_id (), parent_frame_rid);
-  region_id a_in_parent_rid = model.get_lvalue (a, &ctxt);
-  model.set_value (a_in_parent_rid, model.get_rvalue (int_42, &ctxt), &ctxt);
-  model.set_to_new_unknown_value (model.get_lvalue (b, &ctxt),
-				  integer_type_node, &ctxt);
+  const region *parent_frame_reg
+    = model.push_frame (DECL_STRUCT_FUNCTION (parent_fndecl),
+			NULL, &ctxt);
+  ASSERT_EQ (model.get_current_frame (), parent_frame_reg);
+  ASSERT_TRUE (model.region_exists_p (parent_frame_reg));
+  const region *a_in_parent_reg = model.get_lvalue (a, &ctxt);
+  model.set_value (a_in_parent_reg,
+		   model.get_rvalue (int_42, &ctxt),
+		   &ctxt);
+  ASSERT_EQ (a_in_parent_reg->maybe_get_frame_region (), parent_frame_reg);
+
   model.add_constraint (b, LT_EXPR, int_10, &ctxt);
   ASSERT_EQ (model.eval_condition (b, LT_EXPR, int_10, &ctxt),
 	     tristate (tristate::TS_TRUE));
 
   /* Push stack frame for "child_fn".  */
-  region_id child_frame_rid
+  const region *child_frame_reg
     = model.push_frame (DECL_STRUCT_FUNCTION (child_fndecl), NULL, &ctxt);
-  ASSERT_EQ (model.get_current_frame_id (), child_frame_rid);
-  region_id x_in_child_rid = model.get_lvalue (x, &ctxt);
-  model.set_value (x_in_child_rid, model.get_rvalue (int_0, &ctxt), &ctxt);
-  model.set_to_new_unknown_value (model.get_lvalue (y, &ctxt),
-				  integer_type_node, &ctxt);
+  ASSERT_EQ (model.get_current_frame (), child_frame_reg);
+  ASSERT_TRUE (model.region_exists_p (child_frame_reg));
+  const region *x_in_child_reg = model.get_lvalue (x, &ctxt);
+  model.set_value (x_in_child_reg,
+		   model.get_rvalue (int_0, &ctxt),
+		   &ctxt);
+  ASSERT_EQ (x_in_child_reg->maybe_get_frame_region (), child_frame_reg);
+
   model.add_constraint (y, NE_EXPR, int_5, &ctxt);
   ASSERT_EQ (model.eval_condition (y, NE_EXPR, int_5, &ctxt),
 	     tristate (tristate::TS_TRUE));
 
   /* Point a global pointer at a local in the child frame:  p = &x.  */
-  region_id p_in_globals_rid = model.get_lvalue (p, &ctxt);
-  model.set_value (p_in_globals_rid,
-		   model.get_or_create_ptr_svalue (ptr_type_node,
-						   x_in_child_rid),
+  const region *p_in_globals_reg = model.get_lvalue (p, &ctxt);
+  model.set_value (p_in_globals_reg,
+		   mgr.get_ptr_svalue (ptr_type_node, x_in_child_reg),
 		   &ctxt);
+  ASSERT_EQ (p_in_globals_reg->maybe_get_frame_region (), NULL);
 
   /* Point another global pointer at p: q = &p.  */
-  region_id q_in_globals_rid = model.get_lvalue (q, &ctxt);
-  model.set_value (q_in_globals_rid,
-		   model.get_or_create_ptr_svalue (ptr_type_node,
-						   p_in_globals_rid),
+  const region *q_in_globals_reg = model.get_lvalue (q, &ctxt);
+  model.set_value (q_in_globals_reg,
+		   mgr.get_ptr_svalue (ptr_type_node, p_in_globals_reg),
 		   &ctxt);
 
-  /* Test get_descendents.  */
-  region_id_set descendents (&model);
-  model.get_descendents (child_frame_rid, &descendents, region_id::null ());
-  ASSERT_TRUE (descendents.region_p (child_frame_rid));
-  ASSERT_TRUE (descendents.region_p (x_in_child_rid));
-  ASSERT_FALSE (descendents.region_p (a_in_parent_rid));
-  ASSERT_EQ (descendents.num_regions (), 3);
-#if 0
-  auto_vec<region_id> test_vec;
-  for (region_id_set::iterator_t iter = descendents.begin ();
-       iter != descendents.end ();
-       ++iter)
-    test_vec.safe_push (*iter);
-  gcc_unreachable (); // TODO
-  //ASSERT_EQ ();
-#endif
-
-  ASSERT_DUMP_EQ (model, true,
-		  "a: 42, x: 0, p: &x, q: &p, {b, y}: unknown, b < 10, y != 5");
+  /* Test region::descendent_of_p.  */
+  ASSERT_TRUE (child_frame_reg->descendent_of_p (child_frame_reg));
+  ASSERT_TRUE (x_in_child_reg->descendent_of_p (child_frame_reg));
+  ASSERT_FALSE (a_in_parent_reg->descendent_of_p (child_frame_reg));
 
   /* Pop the "child_fn" frame from the stack.  */
-  purge_stats purged;
-  model.pop_frame (region_id::null (), true, &purged, &ctxt);
-
-  /* We should have purged the unknown values for x and y. */
-  ASSERT_EQ (purged.m_num_svalues, 2);
-
-  /* We should have purged the frame region and the regions for x and y. */
-  ASSERT_EQ (purged.m_num_regions, 3);
-
-  /* We should have purged the constraint on y.  */
-  ASSERT_EQ (purged.m_num_equiv_classes, 1);
-  ASSERT_EQ (purged.m_num_constraints, 1);
+  model.pop_frame (NULL, NULL, &ctxt);
+  ASSERT_FALSE (model.region_exists_p (child_frame_reg));
+  ASSERT_TRUE (model.region_exists_p (parent_frame_reg));
 
   /* Verify that p (which was pointing at the local "x" in the popped
      frame) has been poisoned.  */
-  svalue *new_p_sval = model.get_svalue (model.get_rvalue (p, &ctxt));
+  const svalue *new_p_sval = model.get_rvalue (p, &ctxt);
   ASSERT_EQ (new_p_sval->get_kind (), SK_POISONED);
   ASSERT_EQ (new_p_sval->dyn_cast_poisoned_svalue ()->get_poison_kind (),
 	     POISON_KIND_POPPED_STACK);
 
   /* Verify that q still points to p, in spite of the region
      renumbering.  */
-  svalue *new_q_sval = model.get_svalue (model.get_rvalue (q, &ctxt));
+  const svalue *new_q_sval = model.get_rvalue (q, &ctxt);
   ASSERT_EQ (new_q_sval->get_kind (), SK_REGION);
   ASSERT_EQ (new_q_sval->dyn_cast_region_svalue ()->get_pointee (),
 	     model.get_lvalue (p, &ctxt));
 
   /* Verify that top of stack has been updated.  */
-  ASSERT_EQ (model.get_current_frame_id (), parent_frame_rid);
+  ASSERT_EQ (model.get_current_frame (), parent_frame_reg);
 
   /* Verify locals in parent frame.  */
   /* Verify "a" still has its value.  */
-  svalue *new_a_sval = model.get_svalue (model.get_rvalue (a, &ctxt));
+  const svalue *new_a_sval = model.get_rvalue (a, &ctxt);
   ASSERT_EQ (new_a_sval->get_kind (), SK_CONSTANT);
   ASSERT_EQ (new_a_sval->dyn_cast_constant_svalue ()->get_constant (),
 	     int_42);
@@ -8180,7 +3493,7 @@ test_stack_frames ()
 }
 
 /* Verify that get_representative_path_var works as expected, that
-   we can map from region ids to parms and back within a recursive call
+   we can map from regions to parms and back within a recursive call
    stack.  */
 
 static void
@@ -8197,67 +3510,88 @@ test_get_representative_path_var ()
 		       get_identifier ("n"),
 		       integer_type_node);
 
-  region_model model;
+  region_model_manager mgr;
+  test_region_model_context ctxt;
+  region_model model (&mgr);
 
   /* Push 5 stack frames for "factorial", each with a param  */
-  auto_vec<region_id> parm_rids;
-  auto_vec<svalue_id> parm_sids;
+  auto_vec<const region *> parm_regs;
+  auto_vec<const svalue *> parm_svals;
   for (int depth = 0; depth < 5; depth++)
     {
-      region_id frame_rid
-	= model.push_frame (DECL_STRUCT_FUNCTION (fndecl), NULL, NULL);
-      region_id rid_n = model.get_lvalue (path_var (n, depth), NULL);
-      parm_rids.safe_push (rid_n);
+      const region *frame_n_reg
+	= model.push_frame (DECL_STRUCT_FUNCTION (fndecl), NULL, &ctxt);
+      const region *parm_n_reg = model.get_lvalue (path_var (n, depth), &ctxt);
+      parm_regs.safe_push (parm_n_reg);
 
-      ASSERT_EQ (model.get_region (rid_n)->get_parent (), frame_rid);
-
-      svalue_id sid_n
-	= model.set_to_new_unknown_value (rid_n, integer_type_node, NULL);
-      parm_sids.safe_push (sid_n);
+      ASSERT_EQ (parm_n_reg->get_parent_region (), frame_n_reg);
+      const svalue *sval_n = mgr.get_or_create_initial_value (parm_n_reg);
+      parm_svals.safe_push (sval_n);
     }
 
   /* Verify that we can recognize that the regions are the parms,
      at every depth.  */
   for (int depth = 0; depth < 5; depth++)
     {
-      ASSERT_EQ (model.get_representative_path_var (parm_rids[depth]),
-		 path_var (n, depth));
+      {
+	svalue_set visited;
+	ASSERT_EQ (model.get_representative_path_var (parm_regs[depth],
+						      &visited),
+		   path_var (n, depth + 1));
+      }
       /* ...and that we can lookup lvalues for locals for all frames,
 	 not just the top.  */
       ASSERT_EQ (model.get_lvalue (path_var (n, depth), NULL),
-		 parm_rids[depth]);
+		 parm_regs[depth]);
       /* ...and that we can locate the svalues.  */
-      auto_vec<path_var> pvs;
-      model.get_path_vars_for_svalue (parm_sids[depth], &pvs);
-      ASSERT_EQ (pvs.length (), 1);
-      ASSERT_EQ (pvs[0], path_var (n, depth));
+      {
+	svalue_set visited;
+	ASSERT_EQ (model.get_representative_path_var (parm_svals[depth],
+						      &visited),
+		   path_var (n, depth + 1));
+      }
     }
 }
 
-/* Verify that the core regions within a region_model are in a consistent
-   order after canonicalization.  */
+/* Ensure that region_model::operator== works as expected.  */
 
 static void
-test_canonicalization_1 ()
+test_equality_1 ()
 {
-  region_model model0;
-  model0.get_root_region ()->ensure_stack_region (&model0);
-  model0.get_root_region ()->ensure_globals_region (&model0);
-
-  region_model model1;
-  model1.get_root_region ()->ensure_globals_region (&model1);
-  model1.get_root_region ()->ensure_stack_region (&model1);
+  tree int_42 = build_int_cst (integer_type_node, 42);
+  tree int_17 = build_int_cst (integer_type_node, 17);
 
-  model0.canonicalize (NULL);
-  model1.canonicalize (NULL);
+/* Verify that "empty" region_model instances are equal to each other.  */
+  region_model_manager mgr;
+  region_model model0 (&mgr);
+  region_model model1 (&mgr);
   ASSERT_EQ (model0, model1);
+
+  /* Verify that setting state in model1 makes the models non-equal.  */
+  tree x = build_global_decl ("x", integer_type_node);
+  model0.set_value (x, int_42, NULL);
+  ASSERT_EQ (model0.get_rvalue (x, NULL)->maybe_get_constant (), int_42);
+  ASSERT_NE (model0, model1);
+
+  /* Verify the copy-ctor.  */
+  region_model model2 (model0);
+  ASSERT_EQ (model0, model2);
+  ASSERT_EQ (model2.get_rvalue (x, NULL)->maybe_get_constant (), int_42);
+  ASSERT_NE (model1, model2);
+
+  /* Verify that models obtained from copy-ctor are independently editable
+     w/o affecting the original model.  */
+  model2.set_value (x, int_17, NULL);
+  ASSERT_NE (model0, model2);
+  ASSERT_EQ (model2.get_rvalue (x, NULL)->maybe_get_constant (), int_17);
+  ASSERT_EQ (model0.get_rvalue (x, NULL)->maybe_get_constant (), int_42);
 }
 
 /* Verify that region models for
       x = 42; y = 113;
    and
       y = 113; x = 42;
-   are equal after canonicalization.  */
+   are equal.  */
 
 static void
 test_canonicalization_2 ()
@@ -8267,7 +3601,8 @@ test_canonicalization_2 ()
   tree x = build_global_decl ("x", integer_type_node);
   tree y = build_global_decl ("y", integer_type_node);
 
-  region_model model0;
+  region_model_manager mgr;
+  region_model model0 (&mgr);
   model0.set_value (model0.get_lvalue (x, NULL),
 		    model0.get_rvalue (int_42, NULL),
 		    NULL);
@@ -8275,7 +3610,7 @@ test_canonicalization_2 ()
 		    model0.get_rvalue (int_113, NULL),
 		    NULL);
 
-  region_model model1;
+  region_model model1 (&mgr);
   model1.set_value (model1.get_lvalue (y, NULL),
 		    model1.get_rvalue (int_113, NULL),
 		    NULL);
@@ -8283,8 +3618,6 @@ test_canonicalization_2 ()
 		    model1.get_rvalue (int_42, NULL),
 		    NULL);
 
-  model0.canonicalize (NULL);
-  model1.canonicalize (NULL);
   ASSERT_EQ (model0, model1);
 }
 
@@ -8302,16 +3635,17 @@ test_canonicalization_3 ()
   tree x = build_global_decl ("x", integer_type_node);
   tree y = build_global_decl ("y", integer_type_node);
 
-  region_model model0;
+  region_model_manager mgr;
+  region_model model0 (&mgr);
   model0.add_constraint (x, GT_EXPR, int_3, NULL);
   model0.add_constraint (y, GT_EXPR, int_42, NULL);
 
-  region_model model1;
+  region_model model1 (&mgr);
   model1.add_constraint (y, GT_EXPR, int_42, NULL);
   model1.add_constraint (x, GT_EXPR, int_3, NULL);
 
-  model0.canonicalize (NULL);
-  model1.canonicalize (NULL);
+  model0.canonicalize ();
+  model1.canonicalize ();
   ASSERT_EQ (model0, model1);
 }
 
@@ -8324,14 +3658,15 @@ test_canonicalization_4 ()
   auto_vec<tree> csts;
   append_interesting_constants (&csts);
 
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
 
   unsigned i;
   tree cst;
   FOR_EACH_VEC_ELT (csts, i, cst)
     model.get_rvalue (cst, NULL);
 
-  model.canonicalize (NULL);
+  model.canonicalize ();
 }
 
 /* Assert that if we have two region_model instances
